#!/usr/bin/python3
import json
import dbus
import dbus.service
from gi.repository import GLib
from dbus.mainloop.glib import DBusGMainLoop

class DbusMethod(dbus.service.Object):
    loop = None
    global logger
    def __init__(self):
        DBusGMainLoop(set_as_default=True)  # You must do this before connecting to the bus.
        self.loop = GLib.MainLoop()
        # 创建会话总线
        self.bus = dbus.SystemBus()
        self.obj = dbus.service.Object.__init__(self, dbus.service.BusName('com.kylin.kydevmonit.policy_manager', bus = self.bus), '/kydevmonit/Responser')

    @dbus.service.method('com.kylin.kydevmonit.policy_manager', in_signature='s')
    def middleman(self, json_param):
        session = dbus.SessionBus()
        param = json.loads(json_param)
        bus_name  = param['bus_name']
        object_path = param['object_path']
        method_name = param['method_name']
        interface = param['interface']
        parameters = param['parameters']
        object = session.get_object(bus_name, object_path)
        method = getattr(object, method_name)
        result = method(*parameters, dbus_interface=interface)
        return result

if __name__ == '__main__':
    DbusMethod().loop.run()
